/*
@author Carlos O. Rios
@version 1.0
Collaboration Statement: I worked on the homework assignment alone, using only course materials.
*/

public class Checksum {

	/*
	 * @param args The method will take in a string of 13 single digit numbers
	 */
	public static void main(String[] args) {

	}
	
	/*
	* Takes in a string of numbers and returns and integer array of numbers
	* @param s a string representation of 13 integers (the ISBN number)
	* @return an array of numbers
	*/
	public int[] toIntArr(String s){
		int[] arr = new int[13];
		for(int i = 0; i < arr.length; i++){
			arr[i] = (int)s.charAt(i)-48;
		}
		return arr;
	}
	
	/*
	* checks to see if the r is equal to the last digit of the ISBN number
	* @param arr takes the 1st, 3rd, 5th, 7th, 9th and 11th digits of the array to add them and 
	* the 2nd, 4th, 6th, 8th, 10th and 12th digits of the array to add them
	* @return provides whether or not the ISBN is valid
	*/
	public String isISBN(int[] arr){
		int m = 0;
		int n = 0;
		int r = 0;
		//n be the sum of the 1st, 3rd, 5th, 7th, 9th and 11th digits
		for(int i = 0; i < arr.length-1; i+=2){
			m += arr[i];
		}
		//m be the sum of the 2nd, 4th, 6th, 8th, 10th and 12th digits
		for(int i = 1; i <arr.length-1; i+=2){
			n += arr[i];
		}
		//r is the 13th digit
		//checking if the checksum formula is equal to the 13th digit (r)
		r = 10 - ((m + 3*n) % 10);

      //Reference ISBN: 9780321532053
		
		//Conditionals
		
		//Checksum formula: if the solution of the formula equals "r" (the 13th digit). it's a valid ISBN
		if(r==10 && arr[arr.length-1] == 0)
			return "Valid";
		else if(r == arr[arr.length-1])
			return "Valid";
		//if it's not equal to "r", it's not a valid ISBN
		else return "NOT Valid";
	}
}
