/**
@author Carlos O. Rios
Collaboration Statement: I worked on the homework assignment alone, using only course materials.
*/

public class Checksum {

	/**
	 * @param args The method will take in a string of 12 single digit numbers
	 */
	public static void main(String[] args) {
		//Just Testing the Code!
		//Checksum cs = new Checksum();
		//System.out.println(cs.isUPC(cs.toIntArr("790145197047")));

	}
	
	/**
	 * Takes in a string of numbers and returns and integer array of numbers
	 * @param s a string representation of 12 integers (the UPC code number)
	 * @return an array of numbers
	 */
	public int[] toIntArr(String s){
		int[] arr = new int[12];
		for(int i = 0; i < arr.length; i++){
			arr[i] = (int)s.charAt(i)-48;
		}
		return arr;
	}
	
	/**
	 * checks to see if the r is equal to the last digit of the UPC code
	 * @param arr takes the 1st, 3rd, 5th, 7th, 9th and 11th digits of the array to add them and 
	 * the 2nd, 4th, 6th, 8th, and 10th digits of the array to add them
	 * @return provides whether or not the UPC code is valid
	 */
	public String isUPC(int[] arr){
		int m = 0;
		int n = 0;
		int r = 0;
		for(int i = 0; i < arr.length-1; i+=2){//n be the sum of the 1st, 3rd, 5th, 7th, 9th and 11th digits
			n += arr[i];
		}
		for(int i = 1; i <arr.length-1; i+=2){//m be the sum of the 2nd, 4th, 6th, 8th, and 10th digits
			m += arr[i];
		}
		r = 10 - ((m + 3*n) % 10);
//		System.out.println("m is " + m);
//		System.out.println("n is " + n);
//		System.out.println("r is " + r);
		if(r==10 && arr[arr.length-1] == 0)
			return "True";
		else if(r == arr[arr.length-1])
			return "True";
		else return "False";
	}
}
